module DTD_Reservas where

import Xml2Haskell


{-Type decls-}

newtype Reservas = Reservas [Reserva] 		deriving (Eq,Show)
data Reserva = Reserva Recurso [Quando] Responsavel Login Setor
		       Motivo
	     deriving (Eq,Show)
newtype Recurso = Recurso String 		deriving (Eq,Show)
data Quando = Quando Dia Mes Ano Hora_inicio Hora_fim
	    deriving (Eq,Show)
newtype Dia = Dia String 		deriving (Eq,Show)
newtype Mes = Mes String 		deriving (Eq,Show)
newtype Ano = Ano String 		deriving (Eq,Show)
newtype Hora_inicio = Hora_inicio String 		deriving (Eq,Show)
newtype Hora_fim = Hora_fim String 		deriving (Eq,Show)
newtype Responsavel = Responsavel String 		deriving (Eq,Show)
newtype Login = Login String 		deriving (Eq,Show)
newtype Setor = Setor String 		deriving (Eq,Show)
newtype Motivo = Motivo String 		deriving (Eq,Show)


{-Instance decls-}

instance XmlContent Reservas where
    fromElem (CElem (Elem "reservas" [] c0):rest) =
	(\(a,ca)->
	   (Just (Reservas a), rest))
	(many fromElem c0)
    fromElem rest = (Nothing, rest)
    toElem (Reservas a) =
	[CElem (Elem "reservas" [] (concatMap toElem a))]
instance XmlContent Reserva where
    fromElem (CElem (Elem "reserva" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (\(f,cf)->
			  (Just (Reserva a b c d e f), rest))
		       (definite fromElem "<motivo>" "reserva" ce))
		    (definite fromElem "<setor>" "reserva" cd))
		 (definite fromElem "<login>" "reserva" cc))
	      (definite fromElem "<responsavel>" "reserva" cb))
	   (many fromElem ca))
	(definite fromElem "<recurso>" "reserva" c0)
    fromElem rest = (Nothing, rest)
    toElem (Reserva a b c d e f) =
	[CElem (Elem "reserva" [] (toElem a ++ concatMap toElem b ++
				   toElem c ++ toElem d ++ toElem e ++ toElem f))]
instance XmlContent Recurso where
    fromElem (CElem (Elem "recurso" [] c0):rest) =
	(\(a,ca)->
	   (Just (Recurso a), rest))
	(definite fromText "text" "recurso" c0)
    fromElem rest = (Nothing, rest)
    toElem (Recurso a) =
	[CElem (Elem "recurso" [] (toText a))]
instance XmlContent Quando where
    fromElem (CElem (Elem "quando" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (\(c,cc)->
		 (\(d,cd)->
		    (\(e,ce)->
		       (Just (Quando a b c d e), rest))
		    (definite fromElem "<hora_fim>" "quando" cd))
		 (definite fromElem "<hora_inicio>" "quando" cc))
	      (definite fromElem "<ano>" "quando" cb))
	   (definite fromElem "<mes>" "quando" ca))
	(definite fromElem "<dia>" "quando" c0)
    fromElem rest = (Nothing, rest)
    toElem (Quando a b c d e) =
	[CElem (Elem "quando" [] (toElem a ++ toElem b ++ toElem c ++
				  toElem d ++ toElem e))]
instance XmlContent Dia where
    fromElem (CElem (Elem "dia" [] c0):rest) =
	(\(a,ca)->
	   (Just (Dia a), rest))
	(definite fromText "text" "dia" c0)
    fromElem rest = (Nothing, rest)
    toElem (Dia a) =
	[CElem (Elem "dia" [] (toText a))]
instance XmlContent Mes where
    fromElem (CElem (Elem "mes" [] c0):rest) =
	(\(a,ca)->
	   (Just (Mes a), rest))
	(definite fromText "text" "mes" c0)
    fromElem rest = (Nothing, rest)
    toElem (Mes a) =
	[CElem (Elem "mes" [] (toText a))]
instance XmlContent Ano where
    fromElem (CElem (Elem "ano" [] c0):rest) =
	(\(a,ca)->
	   (Just (Ano a), rest))
	(definite fromText "text" "ano" c0)
    fromElem rest = (Nothing, rest)
    toElem (Ano a) =
	[CElem (Elem "ano" [] (toText a))]
instance XmlContent Hora_inicio where
    fromElem (CElem (Elem "hora_inicio" [] c0):rest) =
	(\(a,ca)->
	   (Just (Hora_inicio a), rest))
	(definite fromText "text" "hora_inicio" c0)
    fromElem rest = (Nothing, rest)
    toElem (Hora_inicio a) =
	[CElem (Elem "hora_inicio" [] (toText a))]
instance XmlContent Hora_fim where
    fromElem (CElem (Elem "hora_fim" [] c0):rest) =
	(\(a,ca)->
	   (Just (Hora_fim a), rest))
	(definite fromText "text" "hora_fim" c0)
    fromElem rest = (Nothing, rest)
    toElem (Hora_fim a) =
	[CElem (Elem "hora_fim" [] (toText a))]
instance XmlContent Responsavel where
    fromElem (CElem (Elem "responsavel" [] c0):rest) =
	(\(a,ca)->
	   (Just (Responsavel a), rest))
	(definite fromText "text" "responsavel" c0)
    fromElem rest = (Nothing, rest)
    toElem (Responsavel a) =
	[CElem (Elem "responsavel" [] (toText a))]
instance XmlContent Login where
    fromElem (CElem (Elem "login" [] c0):rest) =
	(\(a,ca)->
	   (Just (Login a), rest))
	(definite fromText "text" "login" c0)
    fromElem rest = (Nothing, rest)
    toElem (Login a) =
	[CElem (Elem "login" [] (toText a))]
instance XmlContent Setor where
    fromElem (CElem (Elem "setor" [] c0):rest) =
	(\(a,ca)->
	   (Just (Setor a), rest))
	(definite fromText "text" "setor" c0)
    fromElem rest = (Nothing, rest)
    toElem (Setor a) =
	[CElem (Elem "setor" [] (toText a))]
instance XmlContent Motivo where
    fromElem (CElem (Elem "motivo" [] c0):rest) =
	(\(a,ca)->
	   (Just (Motivo a), rest))
	(definite fromText "text" "motivo" c0)
    fromElem rest = (Nothing, rest)
    toElem (Motivo a) =
	[CElem (Elem "motivo" [] (toText a))]


{-Done-}
