module DTD_dados where

import Xml2Haskell


{-Type decls-}

data Centro = Centro [Pessoa] [Categoria]
	    deriving (Eq,Show)
data Pessoa = Pessoa
    { pessoaCategoria :: String
    , pessoaNome :: String
    , pessoaEmail :: (Maybe String)
    , pessoaSala :: (Maybe String)
    , pessoaRamal :: String
    } deriving (Eq,Show)
newtype Categoria = Categoria String 		deriving (Eq,Show)


{-Instance decls-}

instance XmlContent Centro where
    fromElem (CElem (Elem "centro" [] c0):rest) =
	(\(a,ca)->
	   (\(b,cb)->
	      (Just (Centro a b), rest))
	   (many fromElem ca))
	(many fromElem c0)
    fromElem rest = (Nothing, rest)
    toElem (Centro a b) =
	[CElem (Elem "centro" [] (concatMap toElem a ++
				  concatMap toElem b))]
instance XmlContent Pessoa where
    fromElem (CElem (Elem "pessoa" as []):rest) =
	(Just (fromAttrs as), rest)
    fromElem rest = (Nothing, rest)
    toElem as =
	[CElem (Elem "pessoa" (toAttrs as) [])]
instance XmlAttributes Pessoa where
    fromAttrs as =
	Pessoa
	  { pessoaCategoria = definiteA fromAttrToStr "pessoa" "categoria" as
	  , pessoaNome = definiteA fromAttrToStr "pessoa" "nome" as
	  , pessoaEmail = possibleA fromAttrToStr "email" as
	  , pessoaSala = possibleA fromAttrToStr "sala" as
	  , pessoaRamal = definiteA fromAttrToStr "pessoa" "ramal" as
	  }
    toAttrs v = catMaybes 
	[ toAttrFrStr "categoria" (pessoaCategoria v)
	, toAttrFrStr "nome" (pessoaNome v)
	, maybeToAttr toAttrFrStr "email" (pessoaEmail v)
	, maybeToAttr toAttrFrStr "sala" (pessoaSala v)
	, toAttrFrStr "ramal" (pessoaRamal v)
	]
instance XmlContent Categoria where
    fromElem (CElem (Elem "categoria" [] c0):rest) =
	(\(a,ca)->
	   (Just (Categoria a), rest))
	(definite fromText "text" "categoria" c0)
    fromElem rest = (Nothing, rest)
    toElem (Categoria a) =
	[CElem (Elem "categoria" [] (toText a))]


{-Done-}
