{-********************** Mdulo que implementa as rotinas de pesquisa *********************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro **********************-}

-- ghc -package lang -package std -i../xml-lib -c pesquisas.hs

module Pesquisas where

import DTD_dados
import Char

filtraPorCategoria :: String -> [Pessoa] -> [Pessoa]   
filtraPorCategoria "" lista = lista
filtraPorCategoria categ [] = []
filtraPorCategoria categ ((Pessoa c n e s r):ps) 
	| testEqualStrings categ c = (Pessoa c n e s r):(filtraPorCategoria categ ps)
	| otherwise = filtraPorCategoria categ ps
	
procuraPorLogin :: String -> [Pessoa] -> [Pessoa]
procuraPorLogin login [] = []
procuraPorLogin login ((Pessoa c n e s r):ps) 
	| e == Nothing = procuraPorLogin login ps 	
	| login == (aux e) = [(Pessoa c n e s r)]
	| otherwise = procuraPorLogin login ps 	
		
procuraInexata :: String -> [Pessoa] -> [Pessoa]
procuraInexata str ls = concat (map busca (separaEmPalavras str))
			where busca :: String -> [Pessoa]
			      busca st = procuraPorPalavra st ls 
			      
{--procuraExata :: String -> [Pessoa] -> [Pessoa]
procuraExata nome [] = []
procuraExata nome ((Pessoa c n e s r):ps) 
		| nome == n = (Pessoa c n e s r) : (procuraExata nome ps)	      
		| otherwise = procuraExata nome ps--}
		
--teste
procuraExata :: String -> [Pessoa] -> [Pessoa]
procuraExata nome [] = []
procuraExata nome ((Pessoa c n e s r):ps) 		
		| igual_lista_palavras (separaEmPalavras nome) (separaEmPalavras n) = (Pessoa c n e s r) : (procuraExata nome ps)	      
		| otherwise = procuraExata nome ps		
		
		
igual_lista_palavras :: [String] -> [String] -> Bool
igual_lista_palavras [] [] = True
igual_lista_palavras [] (b:bs) = False
igual_lista_palavras (a:as) [] = False
igual_lista_palavras (a:as) (b:bs) = (testEqualStrings a b) 
				     && (igual_lista_palavras as bs)
		  	  	
procuraPorPalavra :: String -> [Pessoa] -> [Pessoa]
procuraPorPalavra nome [] = []
procuraPorPalavra nome ((Pessoa c n e s r):ps) 
	| subPalavra nome n = (Pessoa c n e s r):(procuraPorPalavra nome ps)    		
	| otherwise = procuraPorPalavra nome ps
	
subPalavra :: String -> String -> Bool
subPalavra str1 str2 = estaNaLista str1 (separaEmPalavras str2)

estaNaLista :: String -> [String] -> Bool
estaNaLista str [] = False
estaNaLista str (l:ls) | (testEqualStrings str l) = True
		       | otherwise = estaNaLista str ls 

--teste		       
lista_sem_repeticao :: [Pessoa] -> [Pessoa]
lista_sem_repeticao [] = []
lista_sem_repeticao (p:ps) = retorna_lista (p:ps) []		       
		       
retorna_lista :: [Pessoa] -> [Pessoa] -> [Pessoa]
retorna_lista [] (b:bs) = (b:bs)
retorna_lista (a:as) lista_nova | pertence_a_lista a lista_nova = retorna_lista as lista_nova
			        | otherwise = retorna_lista as (lista_nova ++ [a])

pertence_a_lista :: Pessoa -> [Pessoa] -> Bool
pertence_a_lista (Pessoa c1 n1 e1 s1 r1) [] = False
pertence_a_lista (Pessoa c1 n1 e1 s1 r1) ((Pessoa c2 n2 e2 s2 r2):ls) 
				| (aux e1) == (aux e2) = True
			        | otherwise = pertence_a_lista (Pessoa c1 n1 e1 s1 r1) ls
		       
		       
{-************************************** Funes auxiliares ****************************-}			

aux :: Maybe String -> String
aux (Just str) = str
aux Nothing = ""	

{--testEqual :: Char -> Char -> Bool
testEqual c1 c2 = (c1 == c2) || (((ord c1) - (ord c2)) == offset) 
		  || (((ord c2) - (ord c1)) == offset)
		       where offset = ord 'A' - ord 'a'--}

--teste		       
testEqual :: Char -> Char -> Bool
testEqual c1 c2 = (c1 == c2) || (((ord c1) - (ord c2)) == offset) 
		  || avalia_acentuacao c1 c2 
		  || (((ord c2) - (ord c1)) == offset)
		       where offset = ord 'A' - ord 'a'
		  	
avalia_acentuacao :: Char -> Char -> Bool		  	
avalia_acentuacao c1 c2 = (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		  	  || (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		          || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		   	  || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		  	  || (c1 == 'i' && c2 == '') || (c1 == '' && c2 == 'i')
		  	  || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		          || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		  	  || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		          || (c1 == 'u' && c2 == '') || (c1 == '' && c2 == 'u')
		  	  || (c1 == 'u' && c2 == '') || (c1 == '' && c2 == 'u')
		    	  || (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		  	  || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		          || (c1 == 'i' && c2 == '') || (c1 == '' && c2 == 'i')
		          || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		       		       
testEqualStrings :: String -> String -> Bool
testEqualStrings [] (b:bs) = False
testEqualStrings (a:as) [] = False
testEqualStrings [] [] = True
testEqualStrings (a:as) (b:bs) = (testEqual a b) && (testEqualStrings as bs)

{--separaEmPalavras :: String -> [String]
separaEmPalavras [] = []
separaEmPalavras str = (f1 str) : separaEmPalavras (f2 str)--}

--teste
separaEmPalavras :: String -> [String]
separaEmPalavras [] = []
separaEmPalavras str 
		| (f1 str) == [] = separaEmPalavras (f2 str)
	        | otherwise = (f1 str) : separaEmPalavras (f2 str)


-- retorna string antes do primeiro separador
f1 :: String -> String
f1 [] = []
f1 (a:as) | not (e_separador a) = a:(f1 as)
	  | otherwise = []
	  
-- retorna string depois do primeiro separador
f2 :: String -> String
f2 [] = []
f2 (a:as) | not (e_separador a) = f2 as
	  | otherwise = as

e_separador :: Char -> Bool
e_separador ch = ch == ' ' || ch == '(' || ch == ')' || ch == ',' || ch == '.' 
		   || ch == ':' || ch == ';' || ch == '!' || ch == '?' || ch == '-'
		   || ch == '_' 	  

			 
{-**************************************************************************************-}