{-********************** Mdulo que implementa as rotinas de pesquisa *********************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro **********************-}

-- ghc -package lang -package std -i../xml-lib -c pesquisas.hs

module Pesquisas_novo where

import DTD_dados
import Char

filtraPorCategoria :: String -> [Pessoa] -> [Pessoa]   
filtraPorCategoria "" lista = lista
filtraPorCategoria categ [] = []
filtraPorCategoria categ ((Pessoa c n e s r):ps) 
	| testEqualStrings categ c = (Pessoa c n e s r):(filtraPorCategoria categ ps)
	| otherwise = filtraPorCategoria categ ps
	
procuraPorLogin :: String -> [Pessoa] -> [Pessoa]
procuraPorLogin login [] = []
procuraPorLogin login ((Pessoa c n e s r):ps) 
	| e == Nothing = procuraPorLogin login ps 	
	| login == (aux e) = [(Pessoa c n e s r)]
	| otherwise = procuraPorLogin login ps 	
					      
procuraParcial :: String -> [Pessoa] -> [Pessoa]
procuraParcial str [] = []			      
procuraParcial str ((Pessoa c n e s r):ps) | (fst (substring str n)) == True  = (Pessoa c n e s r) : (procuraParcial str ps)
					   | otherwise = procuraParcial str ps
			      		
procuraExata :: String -> [Pessoa] -> [Pessoa]
procuraExata str [] = []
procuraExata str ((Pessoa c n e s r):ps) 		
		| let tupla = substring str n in
		 ((fst tupla) == True) && (e_palavra n (snd tupla) 
		 				       (snd tupla + length str - 1)
		 				       (length n))
			    = (Pessoa c n e s r) : (procuraExata str ps)	      		  		
		| otherwise = procuraExata str ps	
		
e_palavra :: String -> Int -> Int -> Int -> Bool
e_palavra str 0 ind2 tam  | ind2 < (tam - 1) = ((str !! ind2) == ' ') || ((str !! (ind2 + 1)) == ' ')
			  | otherwise = True
e_palavra str ind1 ind2 tam | ind2 < (tam - 1) = (((str !! ind1) == ' ') 
				  		  || ((str !! (ind1 - 1)) == ' ')) 
			                         && (((str !! ind2) == ' ') 
			                          || ((str !! (ind2 + 1)) == ' '))
			    | otherwise = (((str !! ind1) == ' ') 
					   || ((str !! (ind1 - 1)) == ' ')) 
				
						      		       
{-************************************** Funes auxiliares ****************************-}			

{-- Retorna verdadeiro de uma string  substring da outra, junto com o ndice em que 
 houve o casamento.  Retorna falso junto com -1 caso contrrio --}
substring :: String -> String -> (Bool, Int)
substring [] (b:bs) = (False, -1)
substring (a:as) [] = (False, -1)
substring (a:as) (b:bs) = aux_substring (a:as) (b:bs) 0 0
		              
aux_substring :: String -> String -> Int -> Int -> (Bool, Int)
aux_substring (a:as) [] n ind | n == (length (a:as))  = (True, (ind - (length (a:as))))
		     	    | otherwise = (False, -1)
aux_substring (a:as) (b:bs) n ind | n == (length (a:as))  = (True, (ind - (length (a:as))))
			        | n /= (length (a:as)) && testEqual ((a:as) !! n) b = aux_substring (a:as) bs (n+1)(ind+1)
		                | otherwise = aux_substring (a:as) bs 0 (ind+1)
		         
aux :: Maybe String -> String
aux (Just str) = str
aux Nothing = ""	

testEqual :: Char -> Char -> Bool
testEqual c1 c2 = (c1 == c2) || (((ord c1) - (ord c2)) == offset) 
		  || avalia_acentuacao c1 c2 
		  || (((ord c2) - (ord c1)) == offset)
		       where offset = ord 'A' - ord 'a'
		  	
avalia_acentuacao :: Char -> Char -> Bool		  	
avalia_acentuacao c1 c2 = (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		  	  || (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		          || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		   	  || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		  	  || (c1 == 'i' && c2 == '') || (c1 == '' && c2 == 'i')
		  	  || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		          || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		  	  || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		          || (c1 == 'u' && c2 == '') || (c1 == '' && c2 == 'u')
		  	  || (c1 == 'u' && c2 == '') || (c1 == '' && c2 == 'u')
		    	  || (c1 == 'a' && c2 == '') || (c1 == '' && c2 == 'a')
		  	  || (c1 == 'e' && c2 == '') || (c1 == '' && c2 == 'e')
		          || (c1 == 'i' && c2 == '') || (c1 == '' && c2 == 'i')
		          || (c1 == 'o' && c2 == '') || (c1 == '' && c2 == 'o')
		       		       
testEqualStrings :: String -> String -> Bool
testEqualStrings [] (b:bs) = False
testEqualStrings (a:as) [] = False
testEqualStrings [] [] = True
testEqualStrings (a:as) (b:bs) = (testEqual a b) && (testEqualStrings as bs)

{-******************************* Funes no mais usadas **********************-}
separaEmPalavras :: String -> [String]
separaEmPalavras [] = []
separaEmPalavras str 
		| (f1 str) == [] = separaEmPalavras (f2 str)
	        | otherwise = (f1 str) : separaEmPalavras (f2 str)

-- retorna string antes do primeiro separador
f1 :: String -> String
f1 [] = []
f1 (a:as) | not (e_separador a) = a:(f1 as)
	  | otherwise = []
	  
-- retorna string depois do primeiro separador
f2 :: String -> String
f2 [] = []
f2 (a:as) | not (e_separador a) = f2 as
	  | otherwise = as

e_separador :: Char -> Bool
e_separador ch = ch == ' ' || ch == '(' || ch == ')' || ch == ',' || ch == '.' 
		   || ch == ':' || ch == ';' || ch == '!' || ch == '?' || ch == '-'
		   || ch == '_' 
		   
igual_lista_palavras :: [String] -> [String] -> Bool
igual_lista_palavras [] [] = True
igual_lista_palavras [] (b:bs) = False
igual_lista_palavras (a:as) [] = False
igual_lista_palavras (a:as) (b:bs) = (testEqualStrings a b) 
				     && (igual_lista_palavras as bs)
		  	  	
procuraPorPalavra :: String -> [Pessoa] -> [Pessoa]
procuraPorPalavra nome [] = []
procuraPorPalavra nome ((Pessoa c n e s r):ps) 
	| subPalavra nome n = (Pessoa c n e s r):(procuraPorPalavra nome ps)    		
	| otherwise = procuraPorPalavra nome ps
	
subPalavra :: String -> String -> Bool
subPalavra str1 str2 = estaNaLista str1 (separaEmPalavras str2)

estaNaLista :: String -> [String] -> Bool
estaNaLista str [] = False
estaNaLista str (l:ls) | (testEqualStrings str l) = True
		       | otherwise = estaNaLista str ls 
			 
{-**************************************************************************************-}