#!/usr/local/bin/runhugs

{-************************ Mdulo que implementa a interface com CGI ************************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro ************************-}

module Main where

import CGI
import Prelude hiding (head)
import Numeric
import List (head)

import IO
import System 
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_Reservas
import Util
	   	 	   		     
-- L o arquivo de recursos		     
main :: IO()
main = do reservas <- readXml arquivo_recursos			        	
	  let (Reservas feitas) = reservas in
	      wrapper (consultarReservas feitas)	     
	    	     	     	    	     	     
arquivo_recursos :: String
arquivo_recursos = "/home/mlbm/public_html/reservas/recursos.xml"

--?? MUDAR ESTE ENDERECO DEPOIS!!!
doc_principal = "http://www.cin.ufpe.br/~mlbm/reservas/reservas.html"

consultarReservas :: [Reserva] -> [(Name,Value)] -> IO (CgiOut HTML)
consultarReservas feitas env =   		
                  system "date > date.txt" >>                  
                  readFile "date.txt" 
                  >>= 
                  \str -> if str == "" then error "arquivo vazio!" else
                  mostrarPagina str rec feitas 
                  {--return Content{mime = page 
					      	"Resultado da busca" 
					      	[] 
					      	[(table "" ["Recurso", 
					      		   "Data", 
					      		   "Incio", 
					      		   "Fim", 
					      		   "Responsvel",
					      		   "Login",
					      		   "Setor",
					      		   "Motivo"]					      		 					      		    
					      		    (mostrarConsulta (ordena (consultarRecurso (converteData (separaEmPalavras str) (indiceMes)) feitas rec) [])
					      		    )
					      	  )
					      	]
					}--}
						where rec = lookup "consulta" env 
						      
						      
	
mostrarPagina :: String -> Maybe String -> [Reserva] -> IO (CgiOut HTML)
mostrarPagina str rec feitas = return Content{mime = page ("Reserva de Laboratrio - " ++ (aux rec)) 
						      [("bgcolor","#AFCFFF")]
						      [(h1 "Reservas dos Laboratrios"),
						       (h4 ((aux rec) ++ ":")),
						       (element "center" [(table "" ["Data", 
					      		   			   "Horrio", 					      		   
					      		   			   "Responsvel",					      		   
					      		   			   "Setor",
					      		   			   "Motivo"]					      		 					      		    
					      		  (mostrarConsulta 
					      		     (ordena 
					      		        (consultarRecurso 
					      		    	  (converteData 
					      		    	    (separaEmPalavras str) 
					      		            (indiceMes)
					      		          ) 
					      		          feitas rec
					      		        ) 
					      		        []
					      		      )
					      		  )
					      		)
					      				 ]
					      	       ),
					      	       (p [(element "address" 
					      	                    [ul 
					      	                      [
					      	                       [(href 
					      	                         (doc_principal ++ "#info_uteis")
					      	                         [(prose "Para alteraes/correes")]
					      	                         )
					      	                       ]
					      	                      ]
					      	                    ]	
					      	           )				      	       
					      	      	  ]
					      	       )
					      	      ]
				   		}
				   
quandoToDate :: Quando -> Date
quandoToDate (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf))
              = (Date ((read d) :: Int)
                      (indiceMes2 m)
                      ((read a) :: Int)
                      ((read hi) :: Int)
                      0
                      0
                )
                  
ordena :: [Reserva] -> [Reserva] -> [Reserva]
ordena [] nova_lista = nova_lista
ordena (r:rs) nova_lista = (ordena rs (insereNaOrdem r nova_lista))
                
                
insereNaOrdem :: Reserva -> [Reserva] -> [Reserva]
insereNaOrdem r [] = [r]
insereNaOrdem (Reserva (Recurso rec1) [horario1] (Responsavel resp1) (Login login1) (Setor setor1) (Motivo mot1)) 
              ((Reserva (Recurso rec2) [horario2] (Responsavel resp2) (Login login2) (Setor setor2) (Motivo mot2)):rs)
              | anterior (quandoToDate horario1) (quandoToDate horario2) = 
                          (Reserva (Recurso rec1) 
                                   [horario1] 
                                   (Responsavel resp1) 
                                   (Login login1) 
                                   (Setor setor1) 
                                   (Motivo mot1)
                           )
                           :
                           (Reserva (Recurso rec2) 
                                    [horario2] 
                                    (Responsavel resp2) 
                                    (Login login2) 
                                    (Setor setor2) 
                                    (Motivo mot2)
                           )
                           :
                           rs               
              | otherwise = (Reserva (Recurso rec2) 
                                    [horario2] 
                                    (Responsavel resp2) 
                                    (Login login2) 
                                    (Setor setor2) 
                                    (Motivo mot2)
                           )
                           :
                           (
                           insereNaOrdem (Reserva (Recurso rec1) 
                                                  [horario1] 
                                                  (Responsavel resp1) 
                                                  (Login login1) 
                                                  (Setor setor1) 
                                                  (Motivo mot1)
                                         ) 
                                         rs
                           )
                                          
                		     	     									
		       				
consultarRecurso :: Date -> [Reserva] -> Maybe String -> [Reserva]
consultarRecurso _ _ Nothing = []
consultarRecurso _ [] _ = []
consultarRecurso hoje ((Reserva (Recurso rec) horarios resp login setor mot):rs) recurso 								
        | (aux recurso) == rec = (separaEmMultiplasReservas (Reserva (Recurso rec) (filtraHorarios hoje horarios) resp login setor mot))				
                                 ++ consultarRecurso hoje rs recurso
        | otherwise = consultarRecurso hoje rs recurso
        
separaEmMultiplasReservas :: Reserva -> [Reserva]
separaEmMultiplasReservas (Reserva (Recurso rec) [] resp login setor mot) = []
separaEmMultiplasReservas (Reserva (Recurso rec) horarios resp login setor mot) =
                          (Reserva (Recurso rec) [(head horarios)] resp login setor mot):
                          separaEmMultiplasReservas (Reserva (Recurso rec) (tail horarios) resp login setor mot)
    

filtraHorarios :: Date -> [Quando] -> [Quando]
filtraHorarios _ [] = []
filtraHorarios hoje ((Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)):hs)
				| anterior (converteData ["",m,d,"0","0","0","",a] indiceMes2) hoje = filtraHorarios hoje hs
				| otherwise = (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)):
					      (filtraHorarios hoje hs)



{-*********************************** Funes que exibem a pgica com os resultados *********************************************-}

mostrarReserva :: Quando -> Recurso -> Responsavel -> Login -> Setor -> Motivo -> [ [HTML] ]
mostrarReserva (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)) 
                       (Recurso r) 
                       (Responsavel resp) 
                       (Login l) 
                       (Setor s) 
                       (Motivo mot) 
				= 
				    [
				      --[prose r], 
				      [prose (d ++ "/" ++ m ++ "/" ++ a)],
				      [prose (hi ++ ":00 s " ++ hf ++ ":00")], 
				      --[prose (hf ++ ":00")], 
				      [prose resp],
				      --[prose l],
				      [prose s],
				      [prose mot]
				    ]
				  
 
mostrarConsulta :: [Reserva] -> [[ [HTML] ]]
mostrarConsulta [] = []
mostrarConsulta ((Reserva (Recurso rec) horarios resp login setor mot):rs) 
				= (mostrarReserva (head horarios) (Recurso rec) resp login setor mot)
					: mostrarConsulta rs  
									    				
