#!/usr/local/bin/runhugs

{-************************ Mdulo que implementa a interface com CGI ************************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro **********************-}

module Main where

import CGI
import Prelude hiding (head)

import IO
import System
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_Reservas
import Util 

main :: IO()
main = do hoje <- dataDeHoje
	  reservas <- readXml arquivo
	  let (Reservas feitas) = reservas in
	     wrapper (fazerReserva hoje feitas)    
	     
arquivo :: String
arquivo = "/home/mlbm/public_html/reservas/recursos.xml"

fazerReserva :: Date -> [Reserva] -> [(Name,Value)] -> IO (CgiOut HTML)
fazerReserva (Date d m a h mi s) feitas env = adicionarReserva  feitas 
                                            ((formataNumero d), (formataNumero m), (show a), (formataNumero h), (formataNumero mi)) 
                                            rec hor resp login setor  mot []
			  where rec = lookup "laboratorio" env
				d1 = lookup "dia1" env 
				m1 = lookup "mes1" env 
				a1 = lookup "ano1" env
				hi1 = lookup "horario_inic1" env
				hf1 = lookup "horario_fim1" env
				d2 = lookup "dia2" env 
				m2 = lookup "mes2" env
				a2 = lookup "ano2" env
				hi2 = lookup "horario_inic2" env
				hf2 = lookup "horario_fim2" env
				d3 = lookup "dia3" env 
				m3 = lookup "mes3" env
				a3 = lookup "ano3" env
				hi3 = lookup "horario_inic3" env
				hf3 = lookup "horario_fim3" env
				d4 = lookup "dia4" env 
				m4 = lookup "mes4" env
				a4 = lookup "ano4" env
				hi4 = lookup "horario_inic4" env
				hf4 = lookup "horario_fim4" env
				d5 = lookup "dia5" env 
				m5 = lookup "mes5" env
				a5 = lookup "ano5" env
				hi5 = lookup "horario_inic5" env
				hf5 = lookup "horario_fim5" env
				d6 = lookup "dia6" env
				m6 = lookup "mes6" env 
				a6 = lookup "ano6" env
				hi6 = lookup "horario_inic6" env
				hf6 = lookup "horario_fim6" env
				resp = lookup "responsavel" env
				login = lookup "e_mail" env
				setor = lookup "setor" env
				outro = lookup "outro_setor" env
				mot = lookup "motivo" env
				hor = [(d1, m1, a1, hi1, hf1),
				       (d2, m2, a2, hi2, hf2),
		     		       (d3, m3, a3, hi3, hf3),
				       (d4, m4, a4, hi4, hf4),
				       (d5, m5, a5, hi5, hf5),
				       (d6, m6, a6, hi6, hf6)]												
				
							  			     
adicionarReserva :: [Reserva]
		    -> (String, String, String, String, String) 
		    -> (Maybe String) 
		    -> [((Maybe String),(Maybe String),(Maybe String),(Maybe String),(Maybe String))] 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 		    
		    -> [Quando] 
		    -> IO (CgiOut HTML)
adicionarReserva feitas (dia,mes,ano,hora,mi) rec [] resp login setor mot horarios = 
		    if reservaFeita feitas (Reserva (Recurso (aux rec)) 
			 				horarios 
			 			       (Responsavel (aux resp)) 
			 			       (Login (aux login))
			 		               (Setor (aux setor))
	   	 		         	       (Motivo (aux mot)))
	   	    then
	   	    	mostrarPagina [(prose "Ao cancelada: a reserva j foi efetuada")]	   	    	
		    else if feitas == [] then
		    	writeXml arquivo
		    		 (Reservas ([(Reserva (Recurso (aux rec)) 
			 				horarios 
			 			       (Responsavel (aux resp)) 
			 			       (Login (aux login))
			 		               (Setor (aux setor))
	   	 		         	       (Motivo (aux mot)))])) >>	
	   	 	writeFile "texto.txt" txt >>			   	 		         	       
	   	 	--system "mail -s \"Reserva de laboratrios - confirmao\" ++ (aux login) ++ < texto.txt" >>	   	 	
	   	 	system ("mail -s \"Reserva de laboratorios - confirmacao \"" ++ " " ++ (aux login) ++ "< texto.txt") >>
	   	 	writeFile "teste_mail.txt" ("mail -s \"Reserva de laboratorios - confirmacao \"" ++ (aux login) ++ "< texto.txt") >>	   	 	 
			mostrarPagina confirmacao 			 
	   	  else 
	   	    writeXml arquivo
		    		(Reservas (feitas ++ [(Reserva (Recurso (aux rec)) 
			 				horarios 
			 			       (Responsavel (aux resp)) 
			 			       (Login (aux login))
			 		               (Setor (aux setor))
	   	 		         	       (Motivo (aux mot)))]))	>>
	   	     writeFile "texto.txt" txt >>	   	 		   	 	
          	    --system ("mail -s \"Reserva de laboratrios - confirmao\"" ++ (aux login) ++ "< texto.txt") >>	   	 		   	        
          	    system ("mail -s \"Reserva de laboratrios - confirmao \"" ++ " " ++ (aux login) ++ "< texto.txt") >>
          	    writeFile "teste_mail.txt" ("mail -s \"Reserva de laboratrios - confirmao \"" ++ (aux login) ++ "< texto.txt") >>	   	 	 
	            mostrarPagina confirmacao     	              		  
		   where txt = "\n-------- Novo pedido de reserva de recurso -----\n"
		   		++ "-------- Data do pedido: " ++ dia ++ "/" ++ mes ++ "/"
		   		++ ano ++  ", hora: " ++ hora ++ ":" ++ mi ++ "\n" 
		   		++ "Laboratrio: " ++ (aux rec) ++ "\n" 			       
		   		++ mostraDias horarios
		   		++ "Responsvel: " ++ (aux resp) ++ "\n"
		   		++ "E-mail: " ++ (aux login) ++ "@cin.ufpe.br" ++ "\n"
		   		++ "Setor: " ++ (aux setor) ++ "\n"
				++ "Motivo: " ++ (aux mot)	
			 endereco = (aux login) ++ "@cin.ufpe.br"										
adicionarReserva feitas (dia,mes,ano,hora,mi) rec ((d,m,a,hi,hf):hs) resp login setor  mot horarios
		     | (aux d) == "00" = adicionarReserva feitas (dia,mes,ano,hora,mi) rec hs resp login 
		     				       setor  mot horarios		     
		     | (aux d) /= "00" && (hi >= hf) = return Content{mime = page "Erro" [] 
			     	              		  [prose ("Intervalo invlido: " ++ (aux d) ++ (aux hi) ++ (aux hf))]} 			       		     
		     | otherwise = adicionarReserva feitas (dia,mes,ano,hora,mi) rec hs resp login setor mot 
 			       		          (horarios ++ [(Quando (Dia (aux d))
			         		    	     	        (Mes (aux m))
			         		    	     	        (Ano (aux a))
			       			               (Hora_inicio (aux hi))
			       			                  (Hora_fim (aux hf)))])
			       			                  


enviar_mail :: String -> String -> IO ExitCode
enviar_mail login texto =  do writeFile "teste.txt" texto
	          	      system ("mail -s \"teste\"" ++ login ++ "< texto.txt")
	          	      
			       			                  
confirmacao :: [HTML]
confirmacao = [(element "br" []),
	    (font "#000000" ["Arial"] "" [(prose ("Seu formulrio de solicitao de reserva de recurso "
	    					  ++ "foi recebido para ser processado.")
	    				  ),
	    				  (p [(prose "Aguarde, voc receber uma comunicao confirmando seu pedido."),
	    			  	      (element "hr" []),
	    	                              p [(element "em" [(prose ("Caso tenha alguma dvida ou necessite de maiores "
	    				                                ++ "esclarecimentos, entre em contato com o")
	    			                               ),
	    			                               (href "mailto:webmaster@cin.ufpe.br" [(prose "webmaster@cin.ufpe.br")])
	    			                              ]
	    			                 )
			    			]
	    				     ]
	    				   )
	       				 ]
	    ),
	    (element "br" []),
	    (attributedElement "div" [("align","right")] 
	    			     [(href "javascript:window.back()"
	    			      	    [(attributedElement "img" 
	    			      	                        [("src","http://www.cin.ufpe.br/~mlbm/imagens/voltar.jpg"),
	    			                                 ("border","0")
	    			                                ]
	    			                                []
	    			             )
	    			            ]			
	    			      )
	    			     ]
	    )	    	    
	   ]
			       			                  
reservaFeita :: [Reserva] -> Reserva -> Bool
reservaFeita [] _ = False
reservaFeita ((Reserva (Recurso rec1) 
		       horarios1 
		      (Responsavel resp1) 
		      (Login login1)
		      (Setor setor1)
	   	      (Motivo mot1)
	      ):rs)
	      (Reserva (Recurso rec2) 
		       horarios2 
		      (Responsavel resp2) 
		      (Login login2)
		      (Setor setor2)
	   	      (Motivo mot2)
	      )
	      | rec1 == rec2 && (igualHorarios horarios1 horarios2) && resp1 == resp2 
	        && login1 == login2 && setor1 == setor2 && mot1 == mot2
	        = True
	      | otherwise = reservaFeita rs (Reserva (Recurso rec2) 
					           horarios2
		                                  (Responsavel resp2) 
		                                  (Login login2)
		                                  (Setor setor2)
	   	                                  (Motivo mot2)
	   	                            )
	   	                         
	      

igualHorarios :: [Quando] -> [Quando] -> Bool
igualHorarios [] [] = True
igualHorarios [] (h:hs) = False
igualHorarios (h:hs) [] = False
igualHorarios ((Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1)):hs1)
	     ((Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2)):hs2)  
	     | d1 == d2 && m1 == m2 && a1 == a2 && hi1 == hi2 && hf1 == hf2 = 
	       igualHorarios hs1 hs2
	     | otherwise = False 	     
			       			                  
mostraDias :: [Quando]  
	       -> String
mostraDias [] = []	       
mostraDias ((Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)):hs) = "Dia: " ++ d ++ "/" ++ m ++ "/" ++ a ++ "\n" ++ 
										  "Horrio: " ++ hi ++ " s " ++ hf ++ "\n" ++ "\n" ++ 
										   mostraDias hs
				
				

			       			       
	       
-- COLOCAR DEPOIS EM OUTRO SCRIPT!	       
mostrarPagina :: [HTML] -> IO (CgiOut HTML)
mostrarPagina body = return Content{mime = page "Reserva de Laboratrio" [("bgcolor", "#FFFFFF"),
								          ("link", "#990000"),
								          ("vlink","#808080"),
								          ("alink", "#A80026")]
			([(img "" "http://www.cin.ufpe.br/~mlbm/imagens/serv2.jpg"),(element "hr" [])] ++ 
			 [font "#000000" ["Arial"] "" body])
}

