#!/usr/local/bin/runhugs

module Main where

import CGI
import Prelude hiding (head)


import IO
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_dados
import Pesquisas_novo

main :: IO()
main = do dados <- readXml arquivo
	  let (Centro l1 l2) = dados in
	     simpleWrapper (pesquisa l1 l2)

arquivo :: String
arquivo = "/home/mlbm/public_html/ramais/cadastro.xml"                  

pesquisa :: [Pessoa] -> [Categoria] -> [(Name,Value)] -> CgiOut HTML
pesquisa elementos categorias env =  if (auxiliar nome == "" && nome /= Nothing) then mostraErro
				      else let resultado = busca categoria nome tipo_busca elementos in
				           mostra_resultados resultado
				      where categoria = lookup "categoria" env 	      
				      	    nome = lookup "nome" env
				            tipo_busca = lookup "busca" env
				   				   
busca :: Maybe String -> Maybe String -> Maybe String -> [Pessoa] -> [Pessoa]
busca (Just categ) Nothing _ elementos = filtraPorCategoria categ elementos
busca (Just "") (Just nome) (Just tipo) elementos = (funcao tipo) nome elementos
busca (Just categ) (Just nome) (Just tipo) elementos = (funcao tipo) nome (filtraPorCategoria categ elementos)

funcao :: String -> (String -> [Pessoa] -> [Pessoa])
funcao "exata" = procuraExata
funcao "parcial" = procuraParcial
funcao "login" = procuraPorLogin

{--OBS.: Posteriormente essa funo poder desenhar o restante da tela.  No momento no
estou com os arquivos de imagem--}
mostra_resultados :: [Pessoa] -> CgiOut HTML
mostra_resultados [] = Content{mime = page 
					"Resultado da busca" 
					[] 
					[prose ("No foram encontrados resultados"
						   ++ " para sua busca.  Verifique "
						   ++ "se o termo est corretamente"
						   ++ " digitado. ")]}					      	
mostra_resultados (p:ps) =  Content{mime = page 
					      	"Resultado da busca" 
					      	[] 
					      	[(table "" ["Categoria", 
					      		   "Nome", 
					      		   "Login", 
					      		   "Sala", 
					      		   "Ramal"]
					      		  (imprimeLista (p:ps))) 
					      	]
					}
					      	
imprimeLista :: [Pessoa] -> [[ [HTML] ]]
imprimeLista [] = []
imprimeLista (p:ps) = (imprimeItem p) : (imprimeLista ps)

imprimeItem :: Pessoa -> [ [HTML] ]
imprimeItem (Pessoa c n e s r) = [[prose c], 
				  [prose n],
				  [prose (auxiliar e)], 
				  [prose (auxiliar s)], 
				  [prose r]]
					      										      
auxiliar :: Maybe String -> String
auxiliar (Just str) | so_ha_espacos str = ""
		    | otherwise = str
auxiliar Nothing = ""		

so_ha_espacos :: String -> Bool
so_ha_espacos [] = True
so_ha_espacos (a:as) | a == ' ' = so_ha_espacos as
		     | otherwise = False		 

mostraErro :: CgiOut HTML
mostraErro = Content{mime = page "Erro" [] [prose "Campo NOME no digitado."]} 
				   
	       
