#!/usr/local/bin/runhugs

module Main where

import CGI
import Prelude hiding (head)


import IO
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_dados
import Pesquisas_novo
	     
main :: IO()
main = catch (do dados <- readXml arquivo
	     	 let (Centro l1 l2) = dados in
	     		simpleWrapper (pesquisa l1 l2))
	     (\e -> simpleWrapper (mostraErro "Impossvel acessar o arquivo de cadastro"))

arquivo :: String
arquivo = "/home/mlbm/public_html/ramais/cadastro.xml" 

pesquisa :: [Pessoa] -> [Categoria] -> [(Name,Value)] -> CgiOut HTML
pesquisa elementos categorias env =   if (auxiliar nome == "" && nome /= Nothing) then 
					   mostraErro "Campo NOME no digitado." env
				      else let resultado = busca categoria nome tipo_busca elementos in
				           mostra_resultados resultado env
				      where categoria = lookup "categoria" env 	      
				      	    nome = lookup "nome" env
				            tipo_busca = lookup "busca" env
				   				   
busca :: Maybe String -> Maybe String -> Maybe String -> [Pessoa] -> [Pessoa]
busca (Just categ) Nothing _ elementos = filtraPorCategoria categ elementos
busca (Just "") (Just nome) (Just tipo) elementos = (funcao tipo) nome elementos
busca (Just categ) (Just nome) (Just tipo) elementos = (funcao tipo) nome (filtraPorCategoria categ elementos)

funcao :: String -> (String -> [Pessoa] -> [Pessoa])
funcao "exata" = procuraExata
funcao "parcial" = procuraParcial
funcao "login" = procuraPorLogin
					
mostra_resultados :: [Pessoa] -> [(Name,Value)] -> CgiOut HTML
mostra_resultados [] env = mostraErro ("No foram encontrados resultados"
				       ++ " para sua busca.  Verifique "
				       ++ "se o termo est corretamente"
				       ++ " digitado. ")
				       env
mostra_resultados resultados env | mostra_categoria (lookup "categoria" env) = 
				   	       imprimePagina [font "#000000" ["Arial"] "" [(table "" [ "Nome",
				   	       		     	          		      		"Login", 
									                      		"Categoria", 
									                      		"Ramal"]
					      		       		  (imprimeLista resultados True))] 
					      		      ]
				 | otherwise = imprimePagina [font "#000000" ["Arial"] "" [(table "" ["Nome", 
				 					 			       "Login", 
				 					 				"Ramal"]
					      	               		(imprimeLista resultados False))] 
					       		     ]

mostra_categoria :: Maybe String -> Bool
mostra_categoria (Just "") = True
mostra_categoria (Just (c:cs)) = False

imprimePagina :: [HTML] -> CgiOut HTML
imprimePagina html = Content{mime = page "Servios/Ramais Telefnicos" 
					      	[] 
					      	[(attributedElement "table" [("width","460"),
					      				   ("border","0"),
					      				   ("cellpadding","0"),
					      				   ("cellspacing","0")]
					      		          [(element "tr" [(attributedElement "td" [("width","230"),
					      		          					("valign","bottom"),
					      		          					("align","right")]
					      		          				   [img "" "http://www.cin.ufpe.br/~mlbm/imagens/r-cinza.jpg"]),
					      		         		 (attributedElement "td" [("width","230"),
					      		          					("valign","bottom"),
					      		          					("align","right")]
					      		          				   [img "" "http://www.cin.ufpe.br/~mlbm/imagens/serv2.jpg"])					      		          				   
					      		          		]),
					      		           (element "tr" [(attributedElement "td" [("colspan","2"),
					      		          					("width","460"),
					      		          					("align","right")]
					      		          				   [(href "../departamento/departamento.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu1.jpg"),("border","0")] []]),
					      		          				    (href "../docentes/corpodocente.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu2.jpg"),("border","0")] []]),
					      		          				    (href "../graduacao/graduacao.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu3.jpg"),("border","0")] []]),
					      		          				    (href "../posgraduacao/pos-grad.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu4.jpg"),("border","0")] []]),
					      		          				    (href "../extensao/extensao2.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu5.jpg"),("border","0")] []]),
					      		          				    (href "../grupos/grupos.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu6.jpg"),("border","0")] []]),
					      		          				    (href "../search.html" 

[attributedElement
"img" [("src","http://www.cin.ufpe.br/~mlbm/imagens/menu7.jpg"),("border","0")] []])
					      		          				   ]
					      		          		   )
					      		         		  
					      		          		 ])
					      		            
					      		          ]),
					      	p html
					      	]
					}		
											
													      	
imprimeLista :: [Pessoa] -> Bool -> [[ [HTML] ]]
imprimeLista [] _ = []
imprimeLista (p:ps) mostrar_categoria = (imprimeItem p mostrar_categoria) : 
					(imprimeLista ps mostrar_categoria)

imprimeItem :: Pessoa -> Bool -> [ [HTML] ]
imprimeItem (Pessoa c n e s r) mostrar_categoria | mostrar_categoria = 
							[[prose n], 
							 [prose (auxiliar e)], 
							 [prose c],
				 			 [prose r]]
				 		 | otherwise = [[prose n], 
							 	[prose (auxiliar e)], 
							 	[prose r]]
					      										      
auxiliar :: Maybe String -> String
auxiliar (Just str) | so_ha_espacos str = ""
		    | otherwise = str
auxiliar Nothing = ""		

so_ha_espacos :: String -> Bool
so_ha_espacos [] = True
so_ha_espacos (a:as) | a == ' ' = so_ha_espacos as
		     | otherwise = False		 

mostraErro :: String -> [(Name,Value)] -> CgiOut HTML 
mostraErro str _ = imprimePagina [font "#000000" ["Arial"] "" [prose str]]
