#!/usr/local/bin/runhugs

{-************************ Mdulo que implementa a interface com CGI ************************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro ************************-}

module Main where

import CGI
import Prelude hiding (head)
import Numeric
import System

import IO
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_Reservas
import DTD_autorizados
import Util


-- L o arquivo de logins autorizados
main :: IO()
main = do autorizados <- readXml arquivo_autorizados	  
	  let (Autorizados logins) = autorizados in
	     principal logins
	   	 	   		     
-- L o arquivo de recursos		     
principal :: [Email] -> IO()
principal logins = do hoje <- dataDeHoje
		      reservas <- readXml arquivo_recursos			        
	       	      let (Reservas feitas) = reservas in
	                 wrapper (fazerReserva hoje feitas logins)	     
	    	     	     
arquivo_recursos :: String
arquivo_recursos = "/home/mlbm/public_html/reservas/recursos.xml"

arquivo_autorizados :: String
arquivo_autorizados = "/home/mlbm/public_html/reservas/autorizados.xml"

fazerReserva :: Date -> [Reserva] -> [Email] -> [(Name,Value)] -> IO (CgiOut HTML)
fazerReserva (Date d m a h mi s) feitas logins env =   if (not (verificaAutorizacao env)) then negado
				 	else if not (estaNaLista login logins) then 
				 		mostrarPagina [prose ("Seu grupo de trabalho no est autorizado a fazer "
				 		   ++ "esta solicitao")]
			              	     else if ((snd resultado) == Nothing) then
			              		mostrarPagina (fst resultado)
			              	            else 
                  				     mostrarPagina 
                  				     	(confirma ((formataNumero d), (formataNumero m), (show a))                   				     		                    				        
                  				        	  (mysnd resultado)
                  				        )
			         	where resultado = verificaReserva (Date d m a h mi s)
                  				     		          feitas 
                  				     		          rec 
                  				     		          hor 
                  				     		          resp 
                  				     		          login 
                  				     		          setor 
                  				     		          outro 
                  				     		          mot 
                  				     		          []
			               	      rec = lookup "laboratorio" env
				              d1 = lookup "dia" env 
				              m1 = lookup "mes" env 
				              a1 = lookup "ano" env
				              hi1 = lookup "horario_inic" env
				              hf1 = lookup "horario_fim" env
				              d2 = lookup "dia2" env 
				              m2 = lookup "mes2" env
				              a2 = lookup "ano2" env
				              hi2 = lookup "horario_inic2" env
				              hf2 = lookup "horario_fim2" env
				              d3 = lookup "dia3" env 
				              m3 = lookup "mes3" env
				              a3 = lookup "ano3" env
				              hi3 = lookup "horario_inic3" env
				              hf3 = lookup "horario_fim3" env 
				              d4 = lookup "dia4" env 
				              m4 = lookup "mes4" env
				              a4 = lookup "ano4" env
				              hi4 = lookup "horario_inic4" env
				              hf4 = lookup "horario_fim4" env
				              d5 = lookup "dia5" env 
				              m5 = lookup "mes5" env
				              a5 = lookup "ano5" env
				              hi5 = lookup "horario_inic5" env
				              hf5 = lookup "horario_fim5" env
				              d6 = lookup "dia6" env
				              m6 = lookup "mes6" env 
				              a6 = lookup "ano6" env
				              hi6 = lookup "horario_inic6" env
				              hf6 = lookup "horario_fim6" env
				              resp = lookup "responsavel" env
				              login = lookup "e_mail" env
				              setor = lookup "setor" env
				              outro = lookup "outro_setor" env
				              mot = lookup "motivo" env
				              hor = [(d1, m1, a1, hi1, hf1),
				       		     (d2, m2, a2, hi2, hf2),
		     		       		     (d3, m3, a3, hi3, hf3),
				       		     (d4, m4, a4, hi4, hf4),
				       		     (d5, m5, a5, hi5, hf5),
				       		     (d6, m6, a6, hi6, hf6)]				              
				              mysnd :: (t,(Maybe u)) -> u
				              mysnd (a,(Just b)) = b
				       							

{-*********************************** Funes de verificao *******************************************-}

estaNaLista :: Maybe String -> [Email] -> Bool
estaNaLista login [] = False
estaNaLista login ((Email l):ls) | (aux login) == l = True
				  | otherwise = estaNaLista login ls 	
type Status = [HTML]

-- Verifica se os intervalos so vlidos e se h choque de horrio.  Caso contrrio, retorna uma reserva.
-- Retorna uma tupla com os seguintes elementos:	
--	* Uma mensagem de status
--	* Uma reserva em caso de sucesso e nada em caso de fracasso	
verificaReserva ::  Date 
                    -> [Reserva] 
		    -> (Maybe String) 
		    -> [((Maybe String),
		         (Maybe String), 
		         (Maybe String), 
		         (Maybe String),
		         (Maybe String))] 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> [Quando] 
		    -> (Status, Maybe Reserva)
verificaReserva dataAtual feitas rec [] resp login setor outro mot horarios = ([(prose "Sucesso")], 
								     Just (Reserva (Recurso (aux rec)) 
			 						     	    horarios 
			 			       		     	           (Responsavel (aux resp)) 
			 			       		     	     	   (Login (aux login))
			 		               		     	           (verificaSetor setor outro)
	   	 		         	       		     	           (Motivo (aux mot))
	   	 		         	       		    	  )
	   	 		         	       		    )
	   	       			where verificaSetor :: (Maybe String) -> (Maybe String) -> Setor
	   	             		      verificaSetor setor outro 
				          			| aux setor == "outro" = Setor (aux outro)
				    	  			| otherwise = Setor (aux setor)			     	              		  
			
verificaReserva dataAtual feitas rec ((d,m,a,hi,hf):hs) resp login setor outro mot horarios		     
		     | (aux d) == "00" = verificaReserva dataAtual feitas rec hs resp login 
		     				       setor outro mot horarios		     
		     | (aux d) /= "00" && (hi >= hf) = (([(prose ("Intervalo invlido: " ++ "das " ++ 
		     						  (aux hi) ++ " s " ++ (aux hf))
		     					 )] ++ (trataErros dataAtual feitas rec hs)),Nothing)
		     | anterior (converteParaData (d,m,a,hi,hf)) dataAtual
		     
		     		= (([(prose ("Hora/dia anterior  hora/dia atual"))] 
		     		   ++ (trataErros dataAtual feitas rec hs)),Nothing)		       			                  
		     		     					 
		     | (aux d) /= "00" && ((length choques) == 0)		       
			       = verificaReserva dataAtual feitas rec hs resp login setor outro 
			    			  mot 
 			       		          (horarios ++ [(Quando (Dia (aux d))
			         		    	     	        (Mes (aux m))
			         		    	     	        (Ano (aux a))
			       			               (Hora_inicio (aux hi))
			       			                  (Hora_fim (aux hf)))])
		     | otherwise = ((choques ++ (trataErros dataAtual feitas rec hs)),Nothing) 
		     		where choques = (verificaChoqueHorario feitas (Recurso (aux rec)) 
		                                   (Quando (Dia (aux d)) 
		                                   	   (Mes (aux m)) 
		                                   	   (Ano (aux a)) 
		                                   	   (Hora_inicio (aux hi)) 
		                                   	   (Hora_fim (aux hf)) ) )
		                                   	   
converteParaData :: ((Maybe String),
		         (Maybe String), 
		         (Maybe String), 
		         (Maybe String),
		         (Maybe String))
		    -> Date
converteParaData (d,m,a,hi,hf) = Date (read (aux d) :: Int) 		     		                                   	   
				      (indiceMes2 (aux m))
				      (read (aux a) :: Int) 		     		                                   	   
				      (read ((separaEmPalavras (aux hi)) !! 0) :: Int)
				      0
				      0

		      
trataErros :: Date -> [Reserva] -> Maybe String -> [((Maybe String),(Maybe String), (Maybe String),(Maybe String),(Maybe String))] -> [HTML] 		      
trataErros _ _ _ [] = []
trataErros dataAtual feitas rec ((d,m,a,hi,hf):hs) 
		     | (aux d) == "00" = trataErros dataAtual feitas rec hs
		     | anterior (converteParaData (d,m,a,hi,hf)) dataAtual
		     			
		     		= ([(prose ("Hora/dia anterior  hora/dia atual"))] 
		     		   ++ (trataErros dataAtual feitas rec hs))
		     
		     | (aux d) /= "00" && (hi >= hf) = [ (prose ("Intervalo invlido: das" 
		     						 	  ++ (aux hi) ++ " s " 
		     						 	  ++ (aux hf)
		     						 )
		     					 ),
		     					(element "br" [])] 
		     					++ (trataErros dataAtual feitas rec hs)		      
		     | otherwise = (verificaChoqueHorario feitas (Recurso (aux rec)) 
		                                   (Quando (Dia (aux d)) 
		                                   	   (Mes (aux m)) 
		                                   	   (Ano (aux a)) 
		                                   	   (Hora_inicio (aux hi)) 
		                                   	   (Hora_fim (aux hf)) ) )
		                    ++ (trataErros dataAtual feitas rec hs)
		                    
verificaChoqueHorario :: [Reserva] -> Recurso -> Quando -> [HTML]
verificaChoqueHorario [] _ _ = []
verificaChoqueHorario ((Reserva rec horarios _ _ _ _):rs) recurso quando
		| rec /= recurso = verificaChoqueHorario rs recurso quando
		| otherwise = (ha_choque horarios quando) ++ (verificaChoqueHorario rs recurso quando)

		
ha_choque :: [Quando] -> Quando -> [HTML]
ha_choque [] _ = []
ha_choque ((Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1)):hs)
	   (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
	   	| a1 /= a2 || m1 /= m2 || d1 /= d2 
	   	    = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
		| (hi2 >= hi1 && hi2 < hf1) || (hf2 <= hf1 && hf2 > hi1) || (hi2 < hi1 && hf2 > hf1)
		    = [(element "b" [prose ("Choque de horrio com outro pedido: ")]),
		       (element "br" []),
		       (element "b" [prose "Dia: "]), (prose (d1 ++ "/" ++ m1 ++ "/" ++ a1)),
		       (element "br" []),
		       (element "b" [prose "Horrio: "]), (prose ("das " ++ hi1 ++ " s " ++ hf1)),
		       (element "br" [])
		      ] ++
		      (ha_choque hs (Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1))) 
		| otherwise = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))		
			   	 		         	       		   			       			      	       
-- PARAMETRIZAR DEPOIS !!!
verificaAutorizacao :: [(Name,Value)] -> Bool
verificaAutorizacao env | maquina == "200.133.0.44" = (startsWith maquina2 "150.161.2") 
							 || (startsWith maquina2 "150.161.19") 
							 || (startsWith maquina2 "150.161.20") 
							 || (startsWith maquina2 "150.161.45") 
							 || (startsWith maquina2 "200.133.34") 
							 || (startsWith maquina2 "200.249.235") 
							 || (startsWith maquina2 "172.17.") 
							 || (startsWith maquina2 "172.19")
							 || maquina2 == "150.161.24.20"		
							 -- || maquina2 == "200227052033-dial-user-uol.acessonet.com.br"							 
			| otherwise = True
				where maquina = aux (lookup "REMOTE_ADDR" env)
				      maquina2 = aux (lookup "HTTP_X_FORWARDED_FOR" env)				      
				
			 

{-****************************************** Funes auxiliares ************************************************-}


--tirar/melhorar depois
negado :: IO (CgiOut HTML)
negado = return Content{mime = page "Erro" [] [prose "Acesso negado"]}  	    

startsWith :: String -> String -> Bool
startsWith [] _ = False
startsWith _ [] = True
startsWith (a:as) (b:bs) | a == b = startsWith as bs
			 | otherwise = False 


{-****************************** Funes que geram a pgina de confirmao ************************************-}   

mostrarPagina :: [HTML] -> IO (CgiOut HTML)
mostrarPagina body = return Content{mime = page "Reserva de Laboratrio" [("bgcolor", "#FFFFFF"),
								          ("link", "#990000"),
								          ("vlink","#808080"),
								          ("alink", "#A80026")]
			([(img "" "http://www.cin.ufpe.br/~mlbm/imagens/serv2.jpg"),(element "hr" [])] ++ 
			 [font "#000000" ["Arial"] "" body])
}

imprimeReserva :: Reserva -> [HTML]
imprimeReserva (Reserva (Recurso rec) horarios (Responsavel resp) (Login login) (Setor setor) (Motivo mot)) =
				 [(element "b" [(prose "Laboratrio: ")]),(prose rec),(element "br" [])] ++
  				  (imprimeDias horarios) ++
  				 [(element "b" [(prose "Responsvel: ")]),(prose resp),(element "br" []),
   				  (element "b" [(prose "E-mail: ")]),(prose login),(element "br" []),
   				  (element "b" [(prose "Motivo: ")]),(prose mot),(element "br" []),
   				  (element "b" [(prose "Setor: ")]),(prose setor)]


confirma :: (String, String, String) -> Reserva -> [HTML]
confirma (d,m,a) reserva = [(font "#000000" ["Arial"] "-1" [(h2 "Verifique seu pedido"),
	  		   			    (attributedElement "p" 
	  		   			    			[("align","right")] 
	  		   			    			[prose ("Hoje: " ++ 
	  		   			    				d ++ 
	  		   			    				"/" ++ 
	  		   			    				m ++ 
	  		   			    				"/" ++ 
	  		   			    				a
	  		   			    			       )
	  		   			    			]
	  		   			    )
	  		   		    ]
 		    ),
 		    (element "center" 
	  	    	     [(attributedElement "table" 
	   	    	  		        [("border","1")]
	                     	       		[(element "tr" 
	                              			  [(attributedElement "td" 
	                                         	 	   	     [("valign","middle")] 
	                                         	 	             [(font "" 
	                                         	       		           ["arial"] 
	                                         	       		           "-1" 
	                                         	       		           [(p (imprimeReserva reserva))]	                                         	       		            
	                                         	       		       )
	                              				   	     ]
	                              			   )
	                              			  ]
	                              		 ),
	                      			(attributedElement "th" 
	                      				 	   [("align","center"),("valign","middle")] 
	                      			 		   (imprimeFormulario (d,m,a) reserva)
	                      			)
	                      		       ]
	                      ),
	                      (element "br" []),
	                      (attributedElement "div" 
	                      			 [("align","right")] 
	                      			 [(href "javascript:window.back()"
	                      			       [(attributedElement "img"
	                      			       			  [("src","http://www.cin.ufpe.br/~mlbm/imagens/voltar.jpg"),
	                      			       			   ("border","0")]
	                      			       			  []
	                      			       	)
	                      			       ]
	                      			  )
	                      			 ]
	                      )
	                      		
	                     ]
	             )
		] 

	   
imprimeDias :: [Quando] -> [HTML]
imprimeDias [] = []	
imprimeDias (h:hs) = (imprimeDia h) ++ (imprimeDias hs)

imprimeDia :: Quando -> [HTML]
imprimeDia (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)) = 
			 [(element "b" [(prose "Dia: ")]),
			  (prose (d ++ "/" ++ m ++ "/" ++ a)),
			  (element "br" []),
			  (element "b" [(prose "Horrio: ")]),
			  (prose ("das " ++ hi ++ " s " ++ hf)),
			  (element "br" [])
			 ]

imprimeFormulario :: (String, String, String) -> Reserva -> [HTML]
imprimeFormulario (d,m,a) (Reserva (Recurso rec) horarios (Responsavel resp) (Login login) (Setor setor) (Motivo mot)) = 
	[(attributedElement "form" [("action",("http://www.cin.ufpe.br/cgi-mlbm/mail3.hs?dia=")),("method","post")]
	 		([(attributedElement "input" [("type","hidden"),("name","laboratorio"),("value",rec)] [])]
			 ++ (imprimeFormularioDias horarios 1) ++
			 [(attributedElement "input" [("type","hidden"),("name","responsavel"),("value",resp)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","e_mail"),("value",login)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","setor"),("value",setor)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","motivo"),("value",mot)] []),
	 		  (submit "" "Confirmar")
	 		 ]
	 		)
	 )
	]
	
imprimeFormularioDias :: [Quando] -> Int -> [HTML]	
imprimeFormularioDias [] n = imprimeRestante n
imprimeFormularioDias ((Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)):hs) n = 
	[(attributedElement "input" [("type","hidden"),("name",("dia" ++ (show n))),("value",d)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("mes" ++ (show n))),("value",m)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("ano" ++ (show n))),("value",a)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("horario_inic" ++ (show n))),("value",hi)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("horario_fim" ++ (show n))),("value",hf)] [])	 
	]
	++
	(imprimeFormularioDias hs (n+1))
	
		    
imprimeRestante :: Int -> [HTML]
imprimeRestante n | n == 7 = []		    
		  | otherwise = 
		    [(attributedElement "input" [("type","hidden"),("name",("dia" ++ (show n))),("value","00")] []),	 
		     (attributedElement "input" [("type","hidden"),("name",("mes" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("ano" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("horario_inic" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("horario_fim" ++ (show n))),("value","00")] [])	 
	            ]
	            ++
	            (imprimeRestante (n+1))	
	
		  	

--OBSERVAES : Precisei modificar a funo ppCloseTag do arquivo CGI.lhs para suportar a tag <br>

