#!/usr/local/bin/runhugs

{-************************ Mdulo que implementa a interface com CGI ************************-}
{-**********************- Autoria: Monique Louise de Barros Monteiro ************************-}

module Main where

import CGI
import Prelude hiding (head)
import Numeric

import IO
import CGI
import Xml2Haskell (readXml, writeXml)

import DTD_Reservas
import DTD_autorizados

-- L o arquivo de logins autorizados
main :: IO()
main = do autorizados <- readXml arquivo_autorizados	  
	  let (Autorizados logins) = autorizados in
	     principal logins
	   	 	   		     
-- L o arquivo de recursos		     
principal :: [Email] -> IO()
principal logins = do --hoje <- dataDeHoje
		      reservas <- readXml arquivo_recursos			        
	       	      let (Reservas feitas) = reservas in
	                 wrapper (consultarReservas feitas logins)	     
	    	     	     
arquivo_recursos :: String
arquivo_recursos = "/home/mlbm/public_html/reservas/recursos.xml"

arquivo_autorizados :: String
arquivo_autorizados = "/home/mlbm/public_html/reservas/autorizados.xml"

consultarReservas :: [Reserva] -> [Email] -> [(Name,Value)] -> IO (CgiOut HTML)
consultarReservas feitas logins env =   return Content{mime = page 
					      	"Resultado da busca" 
					      	[] 
					      	[(table "" ["Recurso", 
					      		   "Data", 
					      		   "Incio", 
					      		   "Fim", 
					      		   "Responsvel",
					      		   "Login",
					      		   "Setor",
					      		   "Motivo"]					      		 
					      		    --[]
					      		    (consultarRecurso feitas rec))
					      	]
					}
						where rec = lookup "consulta" env 
					
					
consultarRecurso :: [Reserva] -> Maybe String -> [[ [HTML] ]]
consultarRecurso _ Nothing = []
consultarRecurso [] _ = []
consultarRecurso ((Reserva (Recurso rec) horarios resp login setor mot):rs) recurso 
				| (aux recurso) == rec = mostrarHorariosReserva horarios (Recurso rec) resp login setor mot
						   ++ consultarRecurso rs recurso
				| otherwise = consultarRecurso rs recurso


mostrarHorariosReserva :: [Quando] -> Recurso -> Responsavel -> Login -> Setor -> Motivo -> [[ [HTML] ]]
mostrarHorariosReserva [] _ _ _ _ _ = []
mostrarHorariosReserva (h:hs) (Recurso r) (Responsavel resp) (Login l) (Setor s) (Motivo m) 
				= (mostrarItem r h resp l s m):
				   (mostrarHorariosReserva hs (Recurso r) 
				   			      (Responsavel resp) 
				   			      (Login l) 
				   			      (Setor s) 
				   			      (Motivo m)) 


mostrarItem :: String -> Quando -> String -> String -> String -> String -> [ [HTML] ]
mostrarItem rec (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)) resp login setor motivo = 
				 [[prose rec], 
				  [prose (d ++ "/" ++ m ++ "/" ++ a)],
				  [prose (hi ++ ":00")], 
				  [prose (hf ++ ":00")], 
				  [prose resp],
				  [prose login],
				  [prose setor],
				  [prose motivo]]

					
				    				
estaNaLista :: Maybe String -> [Email] -> Bool
estaNaLista login [] = False
estaNaLista login ((Email l):ls) | (aux login) == l = True
				  | otherwise = estaNaLista login ls 				

{-*********************************** Funes de verificao *******************************************-}

type Status = [HTML]

-- Verifica se os intervalos so vlidos e se h choque de horrio.  Caso contrrio, retorna uma reserva.
-- Retorna uma tupla com os seguintes elementos:	
--	* Uma mensagem de status
--	* Uma reserva em caso de sucesso e nada em caso de fracasso	
verificaReserva :: [Reserva] 
		    -> (Maybe String) 
		    -> [((Maybe String),
		         (Maybe String), 
		         (Maybe String), 
		         (Maybe String),
		         (Maybe String))] 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> (Maybe String) 
		    -> [Quando] 
		    -> (Status, Maybe Reserva)
verificaReserva feitas rec [] resp login setor outro mot horarios = ([(prose "Sucesso")], 
								     Just (Reserva (Recurso (aux rec)) 
			 						     	    horarios 
			 			       		     	           (Responsavel (aux resp)) 
			 			       		     	     	   (Login (aux login))
			 		               		     	           (verificaSetor setor outro)
	   	 		         	       		     	           (Motivo (aux mot))
	   	 		         	       		    	  )
	   	 		         	       		    )
	   	       			where verificaSetor :: (Maybe String) -> (Maybe String) -> Setor
	   	             		      verificaSetor setor outro 
				          			| aux setor == "outro" = Setor (aux outro)
				    	  			| otherwise = Setor (aux setor)			     	              		  
			
verificaReserva feitas rec ((d,m,a,hi,hf):hs) resp login setor outro mot horarios		     
		     | (aux d) == "00" = verificaReserva feitas rec hs resp login 
		     				       setor outro mot horarios		     
		     | (aux d) /= "00" && (hi >= hf) = (([(prose ("Intervalo invlido: " ++ "das " ++ 
		     						  (aux hi) ++ " s " ++ (aux hf))
		     					 )] ++ (trataErros feitas rec hs)),Nothing)
		     | (aux d) /= "00" && ((length choques) == 0)		       
			       = verificaReserva feitas rec hs resp login setor outro 
			    			  mot 
 			       		          (horarios ++ [(Quando (Dia (aux d))
			         		    	     	        (Mes (aux m))
			         		    	     	        (Ano (aux a))
			       			               (Hora_inicio (aux hi))
			       			                  (Hora_fim (aux hf)))])
		     | otherwise = ((choques ++ (trataErros feitas rec hs)),Nothing) 
		     		where choques = (verificaChoqueHorario feitas (Recurso (aux rec)) 
		                                   (Quando (Dia (aux d)) 
		                                   	   (Mes (aux m)) 
		                                   	   (Ano (aux a)) 
		                                   	   (Hora_inicio (aux hi)) 
		                                   	   (Hora_fim (aux hf)) ) )

		      
trataErros :: [Reserva] -> Maybe String -> [((Maybe String),(Maybe String), (Maybe String),(Maybe String),(Maybe String))] -> [HTML] 		      
trataErros _ _ [] = []
trataErros feitas rec ((d,m,a,hi,hf):hs) 
		     | (aux d) == "00" = trataErros feitas rec hs
		     | (aux d) /= "00" && (hi >= hf) = [ (prose ("Intervalo invlido: das" 
		     						 	  ++ (aux hi) ++ " s " 
		     						 	  ++ (aux hf)
		     						 )
		     					 ),
		     					(element "br" [])] 
		     					++ (trataErros feitas rec hs)		      
		     | otherwise = (verificaChoqueHorario feitas (Recurso (aux rec)) 
		                                   (Quando (Dia (aux d)) 
		                                   	   (Mes (aux m)) 
		                                   	   (Ano (aux a)) 
		                                   	   (Hora_inicio (aux hi)) 
		                                   	   (Hora_fim (aux hf)) ) )
		                    ++ (trataErros feitas rec hs)
		                    
verificaChoqueHorario :: [Reserva] -> Recurso -> Quando -> [HTML]
verificaChoqueHorario [] _ _ = []
verificaChoqueHorario ((Reserva rec horarios _ _ _ _):rs) recurso quando
		| rec /= recurso = verificaChoqueHorario rs recurso quando
		| otherwise = (ha_choque horarios quando) ++ (verificaChoqueHorario rs recurso quando)

		
ha_choque :: [Quando] -> Quando -> [HTML]
ha_choque [] _ = []
ha_choque ((Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1)):hs)
	   (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
	   	| a1 /= a2 || m1 /= m2 || d1 /= d2 
	   	    = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
		| (hi2 >= hi1 && hi2 < hf1) || (hf2 <= hf1 && hf2 > hi1) 
		    = [(element "b" [prose ("Choque de horrio com outro pedido: ")]),
		       (element "br" []),
		       (element "b" [prose "Dia: "]), (prose (d1 ++ "/" ++ m1 ++ "/" ++ a1)),
		       (element "br" []),
		       (element "b" [prose "Horrio: "]), (prose ("das " ++ hi1 ++ " s " ++ hf1)),
		       (element "br" [])
		      ] ++
		      (ha_choque hs (Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1))) 
		| otherwise = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))		
			   	 		         	       		   			       			      	       
-- PARAMETRIZAR DEPOIS !!!
verificaAutorizacao :: [(Name,Value)] -> Bool
verificaAutorizacao env | maquina == "200.133.0.44" = (startsWith maquina2 "150.161.2") 
							 || (startsWith maquina2 "150.161.19") 
							 || (startsWith maquina2 "150.161.20") 
							 || (startsWith maquina2 "150.161.45") 
							 || (startsWith maquina2 "200.133.34") 
							 || (startsWith maquina2 "200.249.235") 
							 || (startsWith maquina2 "172.17.") 
							 || (startsWith maquina2 "172.19")
							 || maquina2 == "150.161.24.20"		
							 -- || maquina2 == "200227052033-dial-user-uol.acessonet.com.br"							 
			| otherwise = True
				where maquina = aux (lookup "REMOTE_ADDR" env)
				      maquina2 = aux (lookup "HTTP_X_FORWARDED_FOR" env)				      
				
			 

{-****************************************** Funes auxiliares ************************************************-}

aux :: (Maybe String) -> String
aux Nothing = ""
aux (Just str) = str		

--tirar/melhorar depois
negado :: IO (CgiOut HTML)
negado = return Content{mime = page "Erro" [] [prose "Acesso negado"]}  	    

startsWith :: String -> String -> Bool
startsWith [] _ = False
startsWith _ [] = True
startsWith (a:as) (b:bs) | a == b = startsWith as bs
			 | otherwise = False 


{-****************************** Funes que geram a pgina de confirmao ************************************-}   

mostrarPagina :: [HTML] -> IO (CgiOut HTML)
mostrarPagina body = return Content{mime = page "Reserva de Laboratrio" [("bgcolor", "#FFFFFF"),
								          ("link", "#990000"),
								          ("vlink","#808080"),
								          ("alink", "#A80026")]
			([(img "" "./imagens/serv2.jpg/sol-reserva.jpg"),(element "hr" [])] ++ 
			 [font "#000000" ["Arial"] "" body])
}

imprimeReserva :: Reserva -> [HTML]
imprimeReserva (Reserva (Recurso rec) horarios (Responsavel resp) (Login login) (Setor setor) (Motivo mot)) =
				 [(element "b" [(prose "Laboratrio: ")]),(prose rec),(element "br" [])] ++
  				  (imprimeDias horarios) ++
  				 [(element "b" [(prose "Responsvel: ")]),(prose resp),(element "br" []),
   				  (element "b" [(prose "E-mail: ")]),(prose login),(element "br" []),
   				  (element "b" [(prose "Motivo: ")]),(prose mot),(element "br" []),
   				  (element "b" [(prose "Setor: ")]),(prose setor)]


confirma :: Reserva -> [HTML]
confirma reserva = [(font "#000000" ["Arial"] "-1" [(h2 "Verifique seu pedido"),
	  		   			    (attributedElement "p" 
	  		   			    			[("align","right")] 
	  		   			    			[prose ("Hoje: ")])]
 		    ),
 		    (element "center" 
	  	    	     [(attributedElement "table" 
	   	    	  		        [("border","1")]
	                     	       		[(element "tr" 
	                              			  [(attributedElement "td" 
	                                         	 	   	     [("valign","middle")] 
	                                         	 	             [(font "" 
	                                         	       		           ["arial"] 
	                                         	       		           "-1" 
	                                         	       		           [(p (imprimeReserva reserva))]	                                         	       		            
	                                         	       		       )
	                              				   	     ]
	                              			   )
	                              			  ]
	                              		 ),
	                      			(attributedElement "th" 
	                      				 	   [("align","center"),("valign","middle")] 
	                      			 		   (imprimeFormulario reserva)
	                      			)
	                      		       ]
	                      ),
	                      (element "br" []),
	                      (attributedElement "div" 
	                      			 [("align","right")] 
	                      			 [(href "javascript:window.back()"
	                      			       [(attributedElement "img"
	                      			       			  [("src","./imagens/voltar.jpg"),
	                      			       			   ("border","0")]
	                      			       			  []
	                      			       	)
	                      			       ]
	                      			  )
	                      			 ]
	                      )
	                      		
	                     ]
	             )
		] 

	   
imprimeDias :: [Quando] -> [HTML]
imprimeDias [] = []	
imprimeDias (h:hs) = (imprimeDia h) ++ (imprimeDias hs)

imprimeDia :: Quando -> [HTML]
imprimeDia (Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)) = 
			 [(element "b" [(prose "Dia: ")]),
			  (prose (d ++ "/" ++ m ++ "/" ++ a)),
			  (element "br" []),
			  (element "b" [(prose "Horrio: ")]),
			  (prose ("das " ++ hi ++ " s " ++ hf)),
			  (element "br" [])
			 ]

imprimeFormulario :: Reserva -> [HTML]
imprimeFormulario (Reserva (Recurso rec) horarios (Responsavel resp) (Login login) (Setor setor) (Motivo mot)) = 
	[(attributedElement "form" [("action","http://www.cin.ufpe.br/cgi-mlbm/mail.hs"),("method","post")]
	 		([(attributedElement "input" [("type","hidden"),("name","laboratorio"),("value",rec)] [])]
			 ++ (imprimeFormularioDias horarios 1) ++
			 [(attributedElement "input" [("type","hidden"),("name","responsavel"),("value",resp)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","e_mail"),("value",login)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","setor"),("value",setor)] []),
	 		  (attributedElement "input" [("type","hidden"),("name","motivo"),("value",mot)] []),
	 		  (submit "" "Confirmar")
	 		 ]
	 		)
	 )
	]
	
imprimeFormularioDias :: [Quando] -> Int -> [HTML]	
imprimeFormularioDias [] n = imprimeRestante n
imprimeFormularioDias ((Quando (Dia d) (Mes m) (Ano a) (Hora_inicio hi) (Hora_fim hf)):hs) n = 
	[(attributedElement "input" [("type","hidden"),("name",("dia" ++ (show n))),("value",d)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("mes" ++ (show n))),("value",m)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("ano" ++ (show n))),("value",a)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("horario_inic" ++ (show n))),("value",hi)] []),	 
	 (attributedElement "input" [("type","hidden"),("name",("horario_fim" ++ (show n))),("value",hf)] [])	 
	]
	++
	(imprimeFormularioDias hs (n+1))
	
		    
imprimeRestante :: Int -> [HTML]
imprimeRestante n | n == 7 = []		    
		  | otherwise = 
		    [(attributedElement "input" [("type","hidden"),("name",("dia" ++ (show n))),("value","00")] []),	 
		     (attributedElement "input" [("type","hidden"),("name",("mes" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("ano" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("horario_inic" ++ (show n))),("value","00")] []),	 
	             (attributedElement "input" [("type","hidden"),("name",("horario_fim" ++ (show n))),("value","00")] [])	 
	            ]
	            ++
	            (imprimeRestante (n+1))	
	
		  	

--OBSERVAES : Precisei modificar a funo ppCloseTag do arquivo CGI.lhs para suportar a tag <br>

